; "eye"
; ZX Spectrum 256b intro
;
; z80 code - .shahmatist
; bugfix   - .ded
;
; 05.01.2023, Samara, Russia
;
; https://emulate.su/rmda/radar.zip
;
; =RMDA=

; load at	#d000	53248
; launch at	#d02a	53294

	DEVICE	ZXSPECTRUM48
	
	org #d000
begin:
		
sin_tab:
	DB #e0,#e0,#df,#1f,#de,#9d,#5c,#9b
	DB #5a,#59,#58,#57,#16,#55,#54,#13
	DB #52,#11,#50,#0f,#4e,#0d,#4c,#0b
	DB #0a,#49,#08,#07,#06,#45,#04,#03
	DB #42,#01
pal_tab:
	DB #89,#8b,#1b,#9a,#92,#16,#b6,#b4,#24,#a5,#ad,#29

start:
scale_x:	equ	#40   
scale_y:	equ	#40   
bufer:		equ	#e000
sinus:		equ	#e300
palette:	equ	#e400

;---IM2------------------------------------
;	di
	ld	a,#ca
	ld	h,a
	dec	a
imlop:	ld	(hl),a
	cp	(hl)
	dec	hl
	jr	z,imlop
	ld	i,a
	im	2

;---sinus-------------------------------------
	ld	de,sinus
	push	de
	pop	iy
	ld	hl,sin_tab
	ld	sp,hl	;init SP
	ld	c,34
sinus2:	ld	a,(hl)
	rlca
	rlca
	and	3
	inc	a
	ld	b,a
	ld	a,(hl)
	and	#3f
	add	a,#20		
sinus1: ld	(de),a
	inc	de
	djnz	sinus1
	inc	hl
	dec	c
	jr	nz,sinus2
	ld	h,d
	ld	l,e
	dec	l
	ld	b,e	;ld bc,#4040
	ld	c,e
sinus3:	ld	a,c
	sbc	a,(hl)
	ld	(de),a
	inc	de
	dec	hl
	djnz	sinus3

	ld	b,e	;ld b,128
	ld	h,d
	ld	l,e
sin3:	dec	hl
	ld	a,(hl)
	ld	(de),a
	inc	de
	djnz	sin3
			
	ld	c,12
	ld	hl,pal_tab
pal_3:	ld	b,10
	ld	a,(hl)
	rlca
	jr	nc,pal_1
	inc	b
pal_1:	ld	a,(hl)
	and	#7F
pal_2:	ld	(de),a
	inc	de
	djnz	pal_2
	inc	hl
	dec	c
	jr	nz,pal_3
;--------------------------------------------------------------
	ld	hl,#5800
chess:
	dec	hl
	ld	a,h
	rra
	sbc	a,a
	xor	%01010101
	ld	(hl),a
	xor	(hl)
	jr	z,chess

;--------------------------------------------------------------
loop:			
	ei
	halt		

;---keyboard---------------------------------------------------
;	xor	a
	in	a,(#fe)
	or	%11100000
	inc	a
	jr	nz,loop

;--------------------------------------------------------------
	ld	hl,bufer
	push	hl
	pop	ix
	ld	de,#5800
	ld	b,#03
	ldir				
	ld	a,(iy)

	ld	(scale_x1+1),a
	ld	(scale_y1+1),a
	inc	iyl

	ld	de,(mod_3)
	ld	a,24
vertical:
	ex	af,af
	ld	bc,(mod_1)
	exx
	ld	b,32
horizont:
	exx
	ld	l,c
	ld	a,(hl)

	ld	l,b
	add	a,(hl)
			
	ld	l,e
	add	a,(hl)

	ld	l,d
	add	a,(hl)

	and	#7f
	ld	(adr+1),a

	and	%11111000
	out	(#fe),a
adr:
	ld	a,(palette)
	ld	(ix),a
	inc	ix
	dec	c
scale_x1:
	ld	a,scale_x
	add	a,b
	ld	b,a
	exx
	djnz	horizont
	exx
scale_y1:
	ld	a,scale_y
	add	a,e
	ld	e,a
	dec	d
	ex	af,af
	dec	a
	jr	nz,vertical
	ld	hl,mod_1
	inc	(hl)
	inc	(hl)
	inc	l
	dec	(hl)
	inc	l
	inc	(hl)
	inc	(hl)
	inc	(hl)
	inc	l
	dec	(hl)
	dec	(hl)
	dec	(hl)
		
	jr	loop
;--------------------------------------------------------------
output:
fin:

mod_1:     equ output	;DB  0;номер знакоместа
mod_2:     equ output+1	;DB  0
mod_3:     equ output+2	;DB  0
mod_4:     equ output+3	;DB  0;номер строки	

	display "START  ",/A,start
	display "BEGIN  ",/A,begin
	display "END    ",/A,fin
	display "LENGTH ",/A,end-begin

	SAVESNA	"eye.sna", start
	SAVEBIN	"eye.bin", begin,fin-begin

	SAVEBIN		"eye", begin,fin-begin
	EMPTYTRD	"eye.trd","eye"
	SAVETRD		"eye.trd","eye.C",begin,fin-begin
;	EMPTYTAP	"eye.tap"
;	SAVETAP		"eye.tap",CODE,"eye",begin,fin-begin

;-------=RMDA=---------------------------------------------[eof]